function [Pts]=harris(I)
% Blaise Pascal University
% Harris.m (Harris corner detector)
%%%%%%%%%%%
%[x,map]=imread('test2.jpg');               
%I=double(x(:,:,1)); % keep red component
%% Compute Harris Score Map
Wx = [-1 0 1 ; -2 0 2 ; -1 0 1];
Wy = Wx';
Ix = masqn(I,Wx);
Iy = masqn(I,Wy);
Ixx = Ix.*Ix ; 
Iyy = Iy.*Iy ;
Ixy = Ix.*Iy ; 
WIxx = masqn(Ixx,gau(2,5)); % sigma = 2 ta = 5
WIyy = masqn(Iyy,gau(2,5)); % sigma = 2 ta = 5
WIxy = masqn(Ixy,gau(2,5)); % sigma = 2 ta = 5
tr = WIxx + WIyy ; 
D = WIxx.*WIyy - WIxy.*WIxy ;

k= 0.04;

R = D - k.*(tr.^2) ; % Harris score

%% Compute Interest Points
th = 0.1;
mask = R>th*max(R(:));
Rs = R.*mask;
mask2 = (masqn(Rs,[-1 0 0 ; 0 1 0 ; 0 0 0])>0) & ...
    (masqn(Rs,[0 -1 0 ; 0 1 0 ; 0 0 0])>0) & ...
    (masqn(Rs,[0 0 -1 ; 0 1 0 ; 0 0 0])>0) &...
    (masqn(Rs,[0 0 0 ; -1 1 0 ; 0 0 0])>0) &...
    (masqn(Rs,[0 0 0 ; 0 1 -1 ; 0 0 0])>0) &...
    (masqn(Rs,[0 0 0 ; 0 1 0 ; -1 0 0])>0) &...
    (masqn(Rs,[0 0 0 ; 0 1 0 ; 0 -1 0])>0) &...
    (masqn(Rs,[0 0 0 ; 0 1 0 ; 0 0 -1])>0);
[l,c]=find(mask2);    
Pts = [c l];
%% Display
% subplot(2,2,1)
% image(x);
% hold on 
% plot(c,l,'+g');
% hold off
% subplot(2,2,2)
% imagesc(R);
% title('R');
% colormap(gray(256));
% subplot(2,2,3)
% imagesc(Rs);
% title('Rs');
% colormap(gray(256));
% subplot(2,2,4)
% imagesc(mask2);
% title('mask2');
% colormap(gray(256));

%% sub-functions
function W=gau(sigma,ta)
W=zeros(ta);
ta2=(ta-1)/2;
for i= -ta2:ta2
    for j= -ta2:ta2
        W(i+ta2+1,j+ta2+1)=exp(-(i^2+j^2)/(2*sigma^2));
    end
end
W = W./sum(W(:));

% Apply kernel m on image I. 
function [I2]=masqn(I,m)

[ty,tx]=size(m);
[Ity, Itx]=size(I);
I2=0.*I;
tmpx=round((tx-1)/2);
tmpy=round((ty-1)/2);
I=[I(1:tmpy,:) ; I ; I(Ity-tmpy+1:Ity,:)];
I=[I(:,1:tmpx) I I(:,Itx-tmpx+1:Itx)];
% 
for i=1:ty  
    for j=1:tx 
        I2=I2+m(i,j).*I(i:end-ty+i,j:end-tx+j);
    end
end
